# TODO Implement something more of an enum, allow for severity comparison, hide constant values
# inspiration: http://gistflow.com/posts/682-ruby-enums-approaches

module UU
  module AppLog
    module ApplicationLog
      # Severity of application log records.
      class Severity
        # The ERROR severity designates error events which prevent normal program
        # execution.
        #
        # This severity is typically configured in production environment. Abusing
        # this severity for debug messages is considered a bad practice and shall
        # be avoided.
        ERROR = 'ERROR'

        # The WARN severity designates potentially harmful situations. Nevertheless
        # these situations still allow the application to continue running.
        #
        # This severity may be configured in production environment only for
        # a reasonably short time (i.e. to track down a bug).
        WARNING = 'WARNING'

        # The INFO severity designates informational messages that highlight the
        # progress of the application at coarse-grained severity.
        #
        # This severity should not be configured in production environment, only
        # in testing and development environments.
        INFO = 'INFO'

        # The DEBUG severity designates fine-grained informational events that are
        # most useful to debug an application.
        #
        # This severity should not be configured in production environment, only
        # in testing and development environments.
        DEBUG = 'DEBUG'
      end
    end
  end
end
